#include "syscall.h"

// _start is the entry point known to the linker

__attribute__((force_align_arg_pointer))
void
_start( void ){

	//------------------------------------------------------------
	//	on entry:
	//------------------------------------------------------------
	//	[sp]		n			# -> argc
	//------------------------------------------------------------
	//	[sp + 8]	&arg_0			@ -> argv
	//			&arg_1
	//			[..]
	//			&arg_n-1
	//	[sp + 8 + n*8]	null
	//------------------------------------------------------------
	//	[sp +16 + n*8]	&env_0			@ -> envp
	//			&env_1
	//			[..]
	//			&env_m-1
	//			null
	//------------------------------------------------------------

	__asm__(
	"xor	%ebp, %ebp		\n"	// mark end of stack frames
	"mov	(%rsp), %edi		\n"	// register edi = 1st arg of main (argc) <- n
	"lea	8(%rsp), %rsi		\n"	// register rsi = 2nd arg of main (argv) <- address of arg_0
	"lea	16(%rsp,%rdi,8), %rdx	\n"	// register rdx = 3rd arg of main (envp) <- address of env_0
	"xor	%eax, %eax		\n"	// register eax <- 0 (ABI)
	"call	main			\n"	// main( %edi, %rsi, %rdx )
	"mov	%eax, %edi		\n"	// register edi = 1st arg of syscall <- return value of main()
	"movl	$60, %eax		\n"	// register eax = syscall-number <- EXIT(60)
	"syscall               		\n"
	);
}
